#ifndef FPGA_GLOBAL_H
#define FPGA_GLOBAL_H

#include <errno.h>

enum log_level {LL_CRITICAL = 0,
		LL_ERROR,
		LL_WARNING,
		LL_INFO,
		LL_DEBUG,
		LL_COUNT};
enum log_level report(enum log_level log_level, const char *format, ...);
void set_log_level(enum log_level log_level);

/* Error codes */
#define ECONN 1000 /* Tried to connect to already connected port */
#define ETYPE 1001 /* Tried an operation on a cell that does not support it */
#define ERECONF 1100 /* Tried to set a configuration bit to multiple values */

#endif // FPGA_GLOBAL_H
